; ------------------------------------------------------------------
; Squaring
; Written by hitchhikr/Neural
; ------------------------------------------------------------------

; ------------------------------------------------------------------
Y_SCREEN_SQUARES        =       128
X_SCREEN_SQUARES        =       464
X_LARG_SQUARES          =       (X_SCREEN_SQUARES/8)

; ------------------------------------------------------------------
                        section prog,code_c

; ------------------------------------------------------------------
start:                  lea     $dff005,a5
                        lea     $7a004,a0
clear_gfx:              clr.l   -(a0)
                        cmp.l   #$40000,a0
                        bhi.b   clear_gfx
                        moveq   #16-1,d7
                        moveq   #0,d0
create_all_squares:     addq.w  #1,d0
                        move.w  d0,d2
                        addq.w  #1,d2
                        and.w   #7,d0
create_a_square:        move.w  d2,d3
draw_loop:              move.l  d2,d5
                        moveq   #Y_SCREEN_SQUARES-2,d6
                        sub.l   d3,d6
                        muls.w  #X_LARG_SQUARES,d6
                        add.w   #(X_SCREEN_SQUARES/2)-32-24,d5
                        move.l  d5,a2
                        bsr.b   draw_point
                        move.w  #(X_SCREEN_SQUARES/2)-32-24,d5
                        sub.w   d2,d5
                        move.l  d5,a1
                        bsr.b   draw_point
                        cmp.w   d2,d3
                        bne.b   no_draw_x
draw_x_line:            move.l  a2,d5
                        bsr.b   draw_point
                        subq.w  #1,a2
                        cmp.w   a1,a2
                        bgt.b   draw_x_line
no_draw_x:              dbf     d3,draw_loop
                        addq.w  #8,d2
                        cmp.w   #(8*20)+1,d2
                        blt.b   create_a_square
                        lea     (X_LARG_SQUARES*(Y_SCREEN_SQUARES)*2)(a0),a0
                        dbf     d7,create_all_squares
                        lea     copperlist-(start-4)(a3),a0
                        move.l  a0,$80-5(a5)
main_loop:              btst.b  #0,(a5)
                        beq.b   main_loop
wait_sync:              btst.b  #0,(a5)
                        bne.b   wait_sync
                        add.l   #(X_LARG_SQUARES*(Y_SCREEN_SQUARES)*2),d0
                        cmp.l   #(X_LARG_SQUARES*(Y_SCREEN_SQUARES)*2)*16,d0
                        bne.b   reset_squares
                        moveq   #0,d0
reset_squares:          move.l  d0,d1
                        add.l   #$40002,d1
                        move.l  d1,$e0-5(a5)
                        bra.b   main_loop

; ------------------------------------------------------------------
draw_point:             move.l  d5,d1
                        lsr.l   #3,d5
                        not.b   d1
                        add.l   d6,d5
                        bset.b  d1,(a0,d5.l)
                        rts

; ------------------------------------------------------------------
copperlist:             dc.w    $9a,$7fff
                        dc.w    $96,$20
                        dc.w    $8e,$2c81,$90,$2cc1
                        dc.w    $92,$38,$94,$d0
                        dc.w    $100,$1200
                        dc.w    $108,X_LARG_SQUARES-40,$1fc,0
                        dc.w    $180,$153,$182,$8f9
                        dc.w    $aa09,-2,$108,-X_LARG_SQUARES-40
